<template>
  <div class="q-pa-md">
    <div>
      <h1>  View & Generate Reports </h1>

      <div class="row">
        <div class="col-sm-3 col-12 text-white">
          <q-select  outlined stack-label
                     v-model="selectedDomain"
                     :options="domainOptions"
                     color="indigo-8"
                     label="Select Domain"
                     :options-dense=true />
        </div>
      </div>

      <div class="row">
        <div class="col-sm-3 col-12 text-white">
          <span >. </span>
        </div>
      </div>

      <div class="row">
        <div class="col-sm-3 col-12 text-white" v-show="showReportOptions">
          <q-banner rounded dense class="bg-grey-3 text-black q-pa-md" >
            <b>Select a report to generate:</b>
            <q-option-group
              :options="reportOptions"
              label="Select a Report"
              type="radio"
              v-model="selectedReport"
            />
          </q-banner>
        </div>
      </div>

    </div>

    <div class="row">
      <div class="actions" align="right" style="max-width: 130px">
          <q-btn color="light-green-4" @click="generateReport" :disable="!showReportOptions">
            <div>Get Report</div>
          </q-btn>
      </div>

      <div style="max-width: 130px" class="text-white">
        <span >. . .</span>
      </div>

      <div class="actions" align="right" style="max-width: 140px">
        <q-btn color="light-green-4" @click="refreshReportPage" :disable="showReportOptions">
          <div>Clear Results</div>
        </q-btn>
      </div>
    </div>

    <div class="q-pa-md" v-show="EOXRecordTableData.length">
      <q-banner rounded dense class="bg-light-green-4 text-black q-pa-md" >
        <b>{{TableName}} returned:  </b><br>{{PaginationResponseRecord.TotalRecords}} record(s) & {{PaginationResponseRecord.LastIndex}} page(s) <br>
        <i>(Exhibiting page {{PaginationResponseRecord.PageIndex}} containing {{PaginationResponseRecord.PageRecords}} records)</i>.
        <template v-slot:action>
          <q-chip dense clickable @click="downloadFile(EOXFileName + '.csv')" icon="save_alt">.csv</q-chip>
        </template>
      </q-banner>
      <div class="q-pa-md" >
        <q-table
          title="EoX Records"
          :columns="EoXRecordTableColumns"
          :data="EOXRecordTableData"
          :rows-per-page-options="[15]"
        />
      </div>
    </div>

    <div class="q-pa-md" v-show="EOXErrorsData.length">
      <q-banner rounded dense class="bg-red-2 text-black q-pa-md">
        <b>{{TableName}} returned error record(s):  </b><br><p v-html="EOXErrorsData"></p>
      </q-banner>
    </div>

  </div>
</template>

<script>
export default {
  data() {
    return {
      showReportOptions: true,
      selectedDomain: null,
      TableName: null,
      domainOptions: [],
      selectedReport: null,
      reportOptions: [
        { label: 'EoX by Product ID', value: 'pid' },
        { label: 'EoX by Serial Number', value: 'sn'},
      ],
      separator: 'cell',
      PaginationResponseRecord: {
        TotalRecords: 0,
        LastIndex: 0,
        PageIndex: 0,
        PageRecords: 0
      },
      EOXRecord: null,
      EOXRecordTableData: [],
      BaseEoXRecordTableColumns: [
        {
          name: "EOLProductID",
          label: "EOLProductID",
          field: "EOLProductID",
          sortable: true
        },
        {
          name: "ProductIDDescription",
          label: "ProductIDDescription",
          field: "ProductIDDescription",
        },
        {
          name: "EOXExternalAnnouncementDate",
          label: "EOXExternalAnnouncementDate",
          field: "EOXExternalAnnouncementDate",
        },
        {
          name: "EndOfSaleDate",
          label: "EndOfSaleDate",
          field: "EndOfSaleDate",
        },
        {
          name: "EndOfSWMaintenanceReleases",
          label: "EndOfSWMaintenanceReleases",
          field: "EndOfSWMaintenanceReleases",
        },
        {
          name: "EndOfSecurityVulSupportDate",
          label:"EndOfSecurityVulSupportDate",
          field: "EndOfSecurityVulSupportDate",
        },
        {
          name: "EndOfRoutineFailureAnalysisDate",
          label:"EndOfRoutineFailureAnalysisDate",
          field: "EndOfRoutineFailureAnalysisDate",
        },
        {
          name:  "EndOfServiceContractRenewal",
          label: "EndOfServiceContractRenewal",
          field:  "EndOfServiceContractRenewal",
        },
        {
          name:  "LastDateOfSupport",
          label: "LastDateOfSupport",
          field:  "LastDateOfSupport",
        },
        {
          name:  "EndOfSvcAttachDate",
          label: "EndOfSvcAttachDate",
          field: "EndOfSvcAttachDate",
        },
        {
          name:  "MigrationInformation",
          label: "MigrationInformation",
          field: "MigrationInformation",
          sortable: false
        },
        {
          name:  "MigrationOption",
          label: "MigrationOption",
          field:  "MigrationOption",
          sortable: false
        },
        {
          name: "MigrationProductId",
          label:"MigrationProductId",
          field:  "MigrationProductId",
          sortable: false
        },
        {
          name:  "MigrationProductName",
          label: "MigrationProductName",
          field:   "MigrationProductName",
          sortable: false
        }
      ],
      EoXRecordTableColumns: [
        {
          name: "EOLProductID",
          label: "EOLProductID",
          field: "EOLProductID",
          sortable: true
        },
        {
          name: "ProductIDDescription",
          label: "ProductIDDescription",
          field: "ProductIDDescription",
        },
        {
          name: "EOXExternalAnnouncementDate",
          label: "EOXExternalAnnouncementDate",
          field: "EOXExternalAnnouncementDate",
        },
        {
          name: "EndOfSaleDate",
          label: "EndOfSaleDate",
          field: "EndOfSaleDate",
        },
        {
          name: "EndOfSWMaintenanceReleases",
          label: "EndOfSWMaintenanceReleases",
          field: "EndOfSWMaintenanceReleases",
        },
        {
          name: "EndOfSecurityVulSupportDate",
          label:"EndOfSecurityVulSupportDate",
          field: "EndOfSecurityVulSupportDate",
        },
        {
          name: "EndOfRoutineFailureAnalysisDate",
          label:"EndOfRoutineFailureAnalysisDate",
          field: "EndOfRoutineFailureAnalysisDate",
        },
        {
          name:  "EndOfServiceContractRenewal",
          label: "EndOfServiceContractRenewal",
          field:  "EndOfServiceContractRenewal",
        },
        {
          name:  "LastDateOfSupport",
          label: "LastDateOfSupport",
          field:  "LastDateOfSupport",
        },
        {
          name:  "EndOfSvcAttachDate",
          label: "EndOfSvcAttachDate",
          field: "EndOfSvcAttachDate",
        },
        {
          name:  "MigrationInformation",
          label: "MigrationInformation",
          field: "MigrationInformation",
          sortable: false
        },
        {
          name:  "MigrationOption",
          label: "MigrationOption",
          field:  "MigrationOption",
          sortable: false
        },
        {
          name: "MigrationProductId",
          label:"MigrationProductId",
          field:  "MigrationProductId",
          sortable: false
        },
        {
          name:  "MigrationProductName",
          label: "MigrationProductName",
          field:   "MigrationProductName",
          sortable: false
        }
      ],
      EOXErrorsData: '',
      EOXFileName: ''
    }
  },
  mounted() {
     this.fetchDomainsData();
  },
  watch:{
    selectedReport: function (val) {
      if (val === 'sn'){
        this.TableName = `EOXBySerialNumber Report for ${this.selectedDomain}`
      }
      else if ( val === 'pid'){
        this.TableName = `EOXByProductID Report for ${this.selectedDomain}`
      }
    }
  },
  methods: {
    fetchDomainsData(){
      const url = `domains`
      this.$axios.get(url)
        .then(response => {
          let i
          for (i in response.data){
            this.domainOptions.push(response.data[i].id);
          }
          console.log(response.data)
        })
        .catch((error) => {
          this.$q.dialog({
            title: 'WARNING!',
            dark: true,
            color: 'red',
            message: error.response.data
          }).onOk(() => {
          })
        })
        .finally(() => {
          this.$q.loading.hide();
        })
    },
    generateReport(){
      this.showReportOptions = false;
      this.$q.loading.show();
      this.EOXRecord = null;
      this.EOXRecordTableData = [];
      this.EOXErrorsData = '';
      this.EOXFileName = '';
      if (this.selectedReport === 'sn'){
        this.EoXRecordTableColumns.unshift(
          {
            name: "EOXInputValue",
            label: "EOXInputValue",
            field: "EOXInputValue",
            sortable: true
          }
        )
      } else {
        this.EoXRecordTableColumns = this.BaseEoXRecordTableColumns
      }
      const url = `reports/${this.selectedReport}/${this.selectedDomain}`
      this.$axios.put(url)
        .then(response => {
          if ('EOXError' in response.data){
              this.EOXErrorsData = response.data.EOXError.ErrorID + ": " + response.data.EOXError.ErrorDescription
          }
          else{
            this.EOXFileName = response.data.FileName;
            console.log('FileName', this.EOXFileName)

            if ('EOXRecord' in response.data){
              console.log('inside EOXRecord')
              this.EOXRecord = response.data.EOXRecord;
              this.PaginationResponseRecord = response.data.PaginationResponseRecord;

              let rec;
              for (rec in this.EOXRecord){
                if ('EOXError' in this.EOXRecord[rec]){
                  if (this.selectedReport === 'pid') {
                    this.EOXErrorsData = this.EOXErrorsData + this.EOXRecord[rec].EOXError.ErrorID + `:` +
                      this.EOXRecord[rec].EOXError.ErrorDescription + "<br>"
                  }
                  else {
                    this.EOXErrorsData = this.EOXErrorsData + this.EOXRecord[rec].EOXError.ErrorID +
                      `: EOL information does not exist for Serial Number -> ` +
                      this.EOXRecord[rec].EOXInputValue + "<br>"
                  }
                }
                else{
                  let data = {
                    EOLProductID: this.EOXRecord[rec].EOLProductID,
                    ProductIDDescription: this.EOXRecord[rec].ProductIDDescription,
                    EOXExternalAnnouncementDate: this.EOXRecord[rec].EOXExternalAnnouncementDate,
                    EndOfSaleDate:	this.EOXRecord[rec].EndOfSaleDate,
                    EndOfSWMaintenanceReleases: this.EOXRecord[rec].EndOfSWMaintenanceReleases,
                    EndOfSecurityVulSupportDate: this.EOXRecord[rec].EndOfSecurityVulSupportDate,
                    EndOfRoutineFailureAnalysisDate: this.EOXRecord[rec].EndOfRoutineFailureAnalysisDate,
                    EndOfServiceContractRenewal: this.EOXRecord[rec].EndOfServiceContractRenewal,
                    LastDateOfSupport: this.EOXRecord[rec].LastDateOfSupport,
                    EndOfSvcAttachDate: this.EOXRecord[rec].EndOfSvcAttachDate,
                    MigrationInformation:	this.EOXRecord[rec].MigrationInformation,
                    MigrationOption: this.EOXRecord[rec].MigrationOption,
                    MigrationProductId:	this.EOXRecord[rec].MigrationProductId,
                    MigrationProductName: this.EOXRecord[rec].MigrationProductName
                  }
                  if (this.selectedReport === 'sn'){
                    data['EOXInputValue'] = this.EOXRecord[rec].EOXInputValue
                  }
                  this.EOXRecordTableData.push(data)
                }
              }
            }
          }
        })
        .catch(() => this.notify('Ops, unexpected error. Please, try again later.', 'error'))
        .finally(() => {
          this.$q.loading.hide();
          // console.log(this.EOXRecordTableData)
        })
    },
    notify(message, icon = 'check') {
      this.$q.notify({icon, position: 'top', message})
    },
    downloadFile(fileName){
      this.$axios({
        method: 'get',
        url: `/download/${fileName}`,
        responseType: 'arraybuffer'
      })
        .then(response => {

          this.forceFileDownload(response, fileName)

        })
        .catch(() => console.log('error occured'))
    },
    forceFileDownload(response, fileName){
      const url = window.URL.createObjectURL(new Blob([response.data]))
      const link = document.createElement('a')
      link.href = url
      link.setAttribute('download', fileName) //or any other extension
      document.body.appendChild(link)
      link.click()
    },
    refreshReportPage(){
      this.showReportOptions = true
      this.EOXRecordTableData = []
      this.EOXErrorsData = []
    }
  }
}
</script>

<style lang="stylus">
  h1
    font-size 1.5rem
    line-height 2rem

  h2
    font-size 0.9rem
    line-height 2rem

  .actions
    margin-top 20px

  .info
    background-color rgb(247, 232, 236)

  .q-chip--dense
    font-size 14px
</style>
